// CasClient.cpp: CCasClient NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "CasClient.h"


#define TCP_TIMEOUT		1000UL		// 1b


CCasClient::CCasClient(ICasClientHandler *pEventHandler, CSmartSock *pSocket)
	: CBcasCard()
	, m_pSocket(pSocket)
	, m_pEventHandler(pEventHandler)
	, m_hClientThread(NULL)
{
	// NCAgXbhN
	DWORD dwThreadID = 0UL;
	if(!(m_hClientThread = ::CreateThread(NULL, 0UL, CCasClient::ClientThreadRaw, (LPVOID)this, 0UL, &dwThreadID))){
		delete this;
		}
}

CCasClient::~CCasClient(void)
{
	delete m_pSocket;
	if(m_hClientThread)::CloseHandle(m_hClientThread);
}

void CCasClient::CloseClient(void)
{
	// NCAgؒf
	m_pSocket->Close();
}

void CCasClient::ClientThread(void)
{
	// J[h[_J
	if(!OpenCard())return;
	
	// Mobt@
	BYTE byDataLen;
	BYTE RecvBuf[256];
	DWORD dwRecvSize;
	
	// bZ[WM[v
	while(1){
		// wb_M
		if(!m_pSocket->Recv(&byDataLen, 1UL, TCP_TIMEOUT)){
			if(m_pSocket->GetLastError() == CSmartSock::EC_TIMEOUT)continue;
			else break;			
			}

		// f[^M
		if(!m_pSocket->Recv(RecvBuf, byDataLen, TCP_TIMEOUT))break;
	
		// J[hM
		if(!TransmitCommand(RecvBuf, byDataLen, &RecvBuf[1], sizeof(RecvBuf) - 1UL, &dwRecvSize))dwRecvSize = 0UL;

		// f[^𑗐M
		RecvBuf[0] = (BYTE)dwRecvSize;
		if(!m_pSocket->Send(RecvBuf, dwRecvSize + 1UL, TCP_TIMEOUT))break;
		}

	// J[h[_
	CloseCard();
}

DWORD WINAPI CCasClient::ClientThreadRaw(LPVOID pParam)
{
	// NCAgXbh
	CCasClient *pThis = static_cast<CCasClient *>(pParam);

	// ڑCxgʒm
	pThis->SendEvent(EID_CONNECTED);
	
	// o֐Ƀ_CNg
	pThis->ClientThread();
	
	// ؒfCxgʒm
	pThis->SendEvent(EID_DISCONNECTED);
	
	delete pThis;
	
	return 0UL;
}

void CCasClient::SendEvent(const DWORD dwEventID, PVOID pParam)
{
	// nhɃCxgʒm
	if(m_pEventHandler)m_pEventHandler->OnCasClientEvent(this, dwEventID, pParam);
}
