// CasProxy.h: CCasProxy NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////


#pragma once


#include "SmartSock.h"


class CCasProxy
{
public:
	enum
	{
		CPEI_ENTERPROCESS,		// vZXJnʒm
		CPEI_EXITPROCESS,		// vZXIʒm
		CPEI_GETSERVERIP,		// T[oIP擾
		CPEI_GETSERVERPORT,		// T[o|[g擾
		CPEI_CONNECTSUCCESS,	// ڑ
		CPEI_CONNECTFAILED,		// ڑs
		CPEI_DISCONNECTED		// ڑؒf
	};
	
	CCasProxy(const HWND hProxyHwnd);
	~CCasProxy(void);

	const BOOL Connect(void);
	const DWORD TransmitCommand(const BYTE *pSendData, const DWORD dwSendSize, BYTE *pRecvData);

	static void SendEnterProcessEvent(const HWND hProxyHwnd);
	static void SendExitProcessEvent(const HWND hProxyHwnd);

protected:
	const DWORD SendProxyEvent(WPARAM wParam) const;

	const HWND m_hProxyHwnd;
	CSmartSock m_Socket;
	
	static DWORD dwErrorDelayTime;
};
